Index: branches/ALPS/HeuristicLab.Tests/HeuristicLab.Scripting-3.3/Scripts/OSGARastriginScriptTest.cs
===================================================================
--- branches/ALPS/HeuristicLab.Tests/HeuristicLab.Scripting-3.3/Scripts/OSGARastriginScriptTest.cs	(revision 11677)
+++ branches/ALPS/HeuristicLab.Tests/HeuristicLab.Scripting-3.3/Scripts/OSGARastriginScriptTest.cs	(revision 11677)
@@ -0,0 +1,79 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.IO;
+using HeuristicLab.Data;
+using HeuristicLab.Persistence.Default.Xml;
+using HeuristicLab.Scripting;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+namespace HeuristicLab.Tests {
+  [TestClass]
+  public class OSGARastriginScriptTest {
+    private const string ScriptFileName = "OSGA_Rastrigin_Script";
+    private const string ScriptItemName = "Offspring Selection Genetic Algorithm Script - Rastrigin";
+    private const string ScriptItemDescription = "A scripted offspring selection genetic algorithm that solves the 100-dimensional Rastrigin test function";
+    private const string LowerBoundVariableName = "minX";
+    private const string UpperBoundVariableName = "maxX";
+    private const string DimensionsVariableName = "N";
+    private const string SeedVariableName = "seed";
+    private const string BestQualityVariableName = "bestFitness";
+
+    [TestMethod]
+    [TestCategory("Scripts.Create")]
+    [TestProperty("Time", "short")]
+    public void CreateOSGARastriginScriptTest() {
+      var script = CreateOSGARastriginScript();
+      string path = Path.Combine(ScriptingUtils.ScriptsDirectory, ScriptFileName + ScriptingUtils.ScriptFileExtension);
+      XmlGenerator.Serialize(script, path);
+    }
+
+    [TestMethod]
+    [TestCategory("Scripts.Execute")]
+    [TestProperty("Time", "long")]
+    public void RunOSGARastriginScriptTest() {
+      var script = CreateOSGARastriginScript();
+
+      script.Compile();
+      ScriptingUtils.RunScript(script);
+
+      var bestQuality = ScriptingUtils.GetVariable<double>(script, BestQualityVariableName);
+      Assert.AreEqual(0.176350329149955, bestQuality, 1E-8);
+    }
+
+    private CSharpScript CreateOSGARastriginScript() {
+      var script = new CSharpScript {
+        Name = ScriptItemName,
+        Description = ScriptItemDescription
+      };
+      #region Variables
+      script.VariableStore.Add(LowerBoundVariableName, new DoubleValue(-5.12));
+      script.VariableStore.Add(UpperBoundVariableName, new DoubleValue(5.12));
+      script.VariableStore.Add(DimensionsVariableName, new IntValue(100));
+      script.VariableStore.Add(SeedVariableName, new IntValue(0));
+      #endregion
+      #region Code
+      script.Code = ScriptingUtils.LoadScriptCodeFromFile(ScriptFileName);
+      #endregion
+      return script;
+    }
+  }
+}
Index: branches/ALPS/HeuristicLab.Tests/HeuristicLab.Tests.csproj
===================================================================
--- branches/ALPS/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 11507)
+++ branches/ALPS/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 11677)
@@ -12,7 +12,8 @@
     <RootNamespace>HeuristicLab.Tests</RootNamespace>
     <AssemblyName>HeuristicLab.Tests</AssemblyName>
-    <TargetFrameworkVersion>v4.0</TargetFrameworkVersion>
+    <TargetFrameworkVersion>v4.5</TargetFrameworkVersion>
     <FileAlignment>512</FileAlignment>
     <ProjectTypeGuids>{3AC096D0-A1C2-E12C-1390-A8335801FDAB};{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}</ProjectTypeGuids>
+    <TargetFrameworkProfile />
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
@@ -24,4 +25,5 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+    <Prefer32Bit>false</Prefer32Bit>
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
@@ -32,4 +34,5 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+    <Prefer32Bit>false</Prefer32Bit>
   </PropertyGroup>
   <PropertyGroup>
@@ -54,4 +57,5 @@
     <CodeAnalysisRuleDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
     <CodeAnalysisIgnoreBuiltInRules>false</CodeAnalysisIgnoreBuiltInRules>
+    <Prefer32Bit>false</Prefer32Bit>
   </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x64'">
@@ -70,4 +74,5 @@
     <CodeAnalysisRuleDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
     <CodeAnalysisIgnoreBuiltInRules>false</CodeAnalysisIgnoreBuiltInRules>
+    <Prefer32Bit>false</Prefer32Bit>
   </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x86'">
@@ -86,4 +91,5 @@
     <CodeAnalysisRuleDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
     <CodeAnalysisIgnoreBuiltInRules>false</CodeAnalysisIgnoreBuiltInRules>
+    <Prefer32Bit>false</Prefer32Bit>
   </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x86'">
@@ -100,7 +106,8 @@
     <CodeAnalysisRuleSetDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\\Rule Sets</CodeAnalysisRuleSetDirectories>
     <CodeAnalysisRuleDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
+    <Prefer32Bit>false</Prefer32Bit>
   </PropertyGroup>
   <ItemGroup>
-    <Reference Include="ALGLIB-3.7.0, Version=3.7.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+    <Reference Include="ALGLIB-3.7.0">
       <HintPath>..\bin\ALGLIB-3.7.0.dll</HintPath>
       <Private>False</Private>
@@ -122,7 +129,7 @@
       <Private>False</Private>
     </Reference>
-    <Reference Include="HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
+    <Reference Include="HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm-3.3">
       <HintPath>..\bin\HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm-3.3.dll</HintPath>
+      <Private>False</Private>
     </Reference>
     <Reference Include="HeuristicLab.Algorithms.ParticleSwarmOptimization-3.3">
@@ -150,5 +157,5 @@
       <Private>False</Private>
     </Reference>
-    <Reference Include="HeuristicLab.Analysis-3.3, Version=3.3.0.0">
+    <Reference Include="HeuristicLab.Analysis-3.3">
       <HintPath>..\bin\HeuristicLab.Analysis-3.3.dll</HintPath>
       <Private>False</Private>
@@ -214,8 +221,11 @@
       <Private>False</Private>
     </Reference>
-    <Reference Include="HeuristicLab.Optimizer-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
+    <Reference Include="HeuristicLab.Optimization.Views-3.3">
+      <HintPath>..\bin\HeuristicLab.Optimization.Views-3.3.dll</HintPath>
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.Optimizer-3.3">
       <HintPath>..\bin\HeuristicLab.Optimizer-3.3.dll</HintPath>
-      <Private>True</Private>
+      <Private>False</Private>
     </Reference>
     <Reference Include="HeuristicLab.ParallelEngine-3.3">
@@ -259,7 +269,7 @@
       <Private>False</Private>
     </Reference>
-    <Reference Include="HeuristicLab.Problems.GrammaticalEvolution-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
+    <Reference Include="HeuristicLab.Problems.GrammaticalEvolution-3.3">
       <HintPath>..\bin\HeuristicLab.Problems.GrammaticalEvolution-3.3.dll</HintPath>
+      <Private>False</Private>
     </Reference>
     <Reference Include="HeuristicLab.Problems.Instances-3.3">
@@ -327,6 +337,5 @@
       <Private>False</Private>
     </Reference>
-    <Reference Include="HeuristicLab.Scripting-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
+    <Reference Include="HeuristicLab.Scripting-3.3">
       <HintPath>..\bin\HeuristicLab.Scripting-3.3.dll</HintPath>
       <Private>False</Private>
@@ -338,4 +347,8 @@
     <Reference Include="HeuristicLab.SequentialEngine-3.3">
       <HintPath>..\bin\HeuristicLab.SequentialEngine-3.3.dll</HintPath>
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="LibSVM-3.12">
+      <HintPath>..\bin\LibSVM-3.12.dll</HintPath>
       <Private>False</Private>
     </Reference>
@@ -358,4 +371,5 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="AssemblyInitializer.cs" />
     <Compile Include="HeuristicLab-3.3\AlgorithmExtensions.cs" />
     <Compile Include="HeuristicLab-3.3\CloningConstructorTest.cs" />
@@ -504,6 +518,34 @@
     <Compile Include="HeuristicLab.Problems.VehicleRouting-3.4\VRPInstancesTest.cs" />
     <Compile Include="HeuristicLab.Random-3.3\RandomEnumerableSampleTest.cs" />
-    <Compile Include="HeuristicLab.Scripting-3.3\GridSearchScriptTest.cs" />
+    <Compile Include="HeuristicLab.Scripting-3.3\Scripts\GAQAPScriptTest.cs" />
+    <Compile Include="HeuristicLab.Scripting-3.3\Scripts\GridSearchRFClassificationScriptTest.cs" />
+    <Compile Include="HeuristicLab.Scripting-3.3\Scripts\GridSearchRFRegressionScriptTest.cs" />
+    <Compile Include="HeuristicLab.Scripting-3.3\Scripts\GridSearchSVMClassificationScriptTest.cs" />
+    <Compile Include="HeuristicLab.Scripting-3.3\Scripts\GridSearchSVMRegressionScriptTest.cs" />
+    <Compile Include="HeuristicLab.Scripting-3.3\ScriptingUtils.cs" />
+    <Compile Include="HeuristicLab.Scripting-3.3\Scripts\GUIAutomationScriptTest.cs" />
+    <Compile Include="HeuristicLab.Scripting-3.3\Scripts\OSGARastriginScriptTest.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="Test Resources\Script Sources\GridSearch_RF_Classification_Script.cs">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </Compile>
+    <Compile Include="Test Resources\Script Sources\GridSearch_RF_Regression_Script.cs">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </Compile>
+    <Compile Include="Test Resources\Script Sources\GridSearch_SVM_Classification_Script.cs">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </Compile>
+    <Compile Include="Test Resources\Script Sources\GridSearch_SVM_Regression_Script.cs">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </Compile>
+    <Compile Include="Test Resources\Script Sources\GA_QAP_Script.cs">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </Compile>
+    <Compile Include="Test Resources\Script Sources\OSGA_Rastrigin_Script.cs">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </Compile>
+    <Compile Include="Test Resources\Script Sources\GUI_Automation_Script.cs">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </Compile>
     <Compile Include="TestRandom.cs" />
   </ItemGroup>
Index: branches/ALPS/HeuristicLab.Tests/Test Resources/Script Sources/GA_QAP_Script.cs
===================================================================
--- branches/ALPS/HeuristicLab.Tests/Test Resources/Script Sources/GA_QAP_Script.cs	(revision 11677)
+++ branches/ALPS/HeuristicLab.Tests/Test Resources/Script Sources/GA_QAP_Script.cs	(revision 11677)
@@ -0,0 +1,69 @@
+﻿using System;
+using System.Linq;
+
+using HeuristicLab.Analysis;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Problems.Instances.QAPLIB;
+using HeuristicLab.Problems.QuadraticAssignment;
+using HeuristicLab.Random;
+
+public class GAQAPScript : HeuristicLab.Scripting.CSharpScriptBase {
+  public override void Main() {
+    DateTime start = DateTime.UtcNow;
+
+    QuadraticAssignmentProblem qap;
+    if (vars.Contains("qap")) qap = vars.qap;
+    else {
+      var provider = new DreznerQAPInstanceProvider();
+      var instance = provider.GetDataDescriptors().Single(x => x.Name == "dre56");
+      var data = provider.LoadData(instance);
+      qap = new QuadraticAssignmentProblem();
+      qap.Load(data);
+      vars.qap = qap;
+    }
+
+    const uint seed = 0;
+    const int popSize = 100;
+    const int generations = 1000;
+    const double mutationRate = 0.05;
+
+    var random = new MersenneTwister(seed);
+    var population = new Permutation[popSize];
+    var qualities = new double[popSize];
+    var nextGen = new Permutation[popSize];
+    var nextQual = new double[popSize];
+
+    var qualityChart = new DataTable("Quality Chart");
+    var qualityRow = new DataRow("Best Quality");
+    qualityChart.Rows.Add(qualityRow);
+    vars.qualityChart = qualityChart;
+
+    for (int i = 0; i < popSize; i++) {
+      population[i] = new Permutation(PermutationTypes.Absolute, qap.Weights.Rows, random);
+      qualities[i] = QAPEvaluator.Apply(population[i], qap.Weights, qap.Distances);
+    }
+    var bestQuality = qualities.Min();
+    var bestQualityGeneration = 0;
+
+    for (int g = 0; g < generations; g++) {
+      var parents = population.SampleProportional(random, 2 * popSize, qualities, windowing: true, inverseProportional: true).ToArray();
+      for (int i = 0; i < popSize; i++) {
+        nextGen[i] = PartiallyMatchedCrossover.Apply(random, parents[i * 2], parents[i * 2 + 1]);
+        if (random.NextDouble() < mutationRate) Swap2Manipulator.Apply(random, nextGen[i]);
+        nextQual[i] = QAPEvaluator.Apply(nextGen[i], qap.Weights, qap.Distances);
+        if (nextQual[i] < bestQuality) {
+          bestQuality = nextQual[i];
+          bestQualityGeneration = g;
+        }
+      }
+      qualityRow.Values.Add(bestQuality);
+      Array.Copy(nextGen, population, popSize);
+      Array.Copy(nextQual, qualities, popSize);
+    }
+
+    vars.elapsed = new TimeSpanValue(DateTime.UtcNow - start);
+    vars.bestQuality = bestQuality;
+    vars.bestQualityFoundAt = bestQualityGeneration;
+  }
+}
Index: branches/ALPS/HeuristicLab.Tests/Test Resources/Script Sources/GUI_Automation_Script.cs
===================================================================
--- branches/ALPS/HeuristicLab.Tests/Test Resources/Script Sources/GUI_Automation_Script.cs	(revision 11677)
+++ branches/ALPS/HeuristicLab.Tests/Test Resources/Script Sources/GUI_Automation_Script.cs	(revision 11677)
@@ -0,0 +1,46 @@
+﻿using System;
+using System.Linq;
+using System.Threading;
+using System.Windows.Forms;
+
+using HeuristicLab.Algorithms.GeneticAlgorithm;
+using HeuristicLab.Core;
+using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
+using HeuristicLab.Optimization;
+using HeuristicLab.Optimization.Views;
+using HeuristicLab.Problems.TravelingSalesman;
+
+public class GUIAutomationScript : HeuristicLab.Scripting.CSharpScriptBase {
+  readonly ManualResetEvent mutex = new ManualResetEvent(false);
+
+  public override void Main() {
+    var ga = new GeneticAlgorithm {
+      MaximumGenerations = { Value = 50 },
+      PopulationSize = { Value = 10 },
+      Problem = new TravelingSalesmanProblem()
+    };
+
+    var experiment = new Experiment();
+    for (int i = 0; i < 5; i++) {
+      experiment.Optimizers.Add(new BatchRun() { Optimizer = (IOptimizer)ga.Clone(), Repetitions = 10 });
+      ga.PopulationSize.Value *= 2;
+    }
+
+    experiment.ExecutionStateChanged += OnExecutionStateChanged;
+    experiment.Start();
+    mutex.WaitOne();
+
+    vars.experiment = experiment;
+    MainFormManager.MainForm.ShowContent(experiment);
+    var viewHost = (ViewHost)MainFormManager.MainForm.ShowContent(experiment.Runs, typeof(RunCollectionBubbleChartView));
+    var bubbleChart = (UserControl)(viewHost.ActiveView);
+    bubbleChart.Controls.OfType<ComboBox>().Single(x => x.Name == "yAxisComboBox").SelectedItem = "BestQuality";
+    bubbleChart.Controls.OfType<ComboBox>().Single(x => x.Name == "xAxisComboBox").SelectedItem = "PopulationSize";
+  }
+
+  private void OnExecutionStateChanged(object sender, EventArgs e) {
+    if (((IExecutable)sender).ExecutionState == ExecutionState.Stopped)
+      mutex.Set();
+  }
+}
Index: branches/ALPS/HeuristicLab.Tests/Test Resources/Script Sources/GridSearch_RF_Classification_Script.cs
===================================================================
--- branches/ALPS/HeuristicLab.Tests/Test Resources/Script Sources/GridSearch_RF_Classification_Script.cs	(revision 11677)
+++ branches/ALPS/HeuristicLab.Tests/Test Resources/Script Sources/GridSearch_RF_Classification_Script.cs	(revision 11677)
@@ -0,0 +1,74 @@
+using System;
+using System.Collections.Generic;
+using System.Linq;
+
+using HeuristicLab.Algorithms.DataAnalysis;
+using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Problems.Instances.DataAnalysis;
+using HeuristicLab.Scripting;
+
+public class RFClassificationCrossValidationScript : HeuristicLab.Scripting.CSharpScriptBase {
+  /* Maximum degree of parallelism (specifies whether or not the grid search should be parallelized) */
+  const int maximumDegreeOfParallelism = 4;
+  /* Number of crossvalidation folds: */
+  const int numberOfFolds = 3;
+  /* Specify whether the folds should be shuffled before doing crossvalidation */
+  const bool shuffleFolds = true;
+
+  /* The tunable Random Forest parameters:
+     - "N" (number of trees). In the random forests literature, this is referred to as the ntree parameter.
+       Larger number of trees produce more stable models and covariate importance estimates, but require more memory and a longer run time.
+       For small datasets, 50 trees may be sufficient. For larger datasets, 500 or more may be required. Please consult the random forests
+       literature for extensive discussion of this parameter (e.g. Cutler et al., 2007; Strobl et al., 2007; Strobl et al., 2008).
+
+     - "R" The ratio of the training set that will be used in the construction of individual trees (0<r<=1). Should be adjusted depending on
+       the noise level in the dataset in the range from 0.66 (low noise) to 0.05 (high noise). This parameter should be adjusted to achieve
+       good generalization error.
+
+     - "M" The ratio of features that will be used in the construction of individual trees (0<m<=1)
+  */
+  static Dictionary<string, IEnumerable<double>> randomForestParameterRanges = new Dictionary<string, IEnumerable<double>> {
+    { "N", ValueGenerator.GenerateSteps(5m, 10, 1).Select(x => Math.Pow(2,(double)x)) },
+    { "R", ValueGenerator.GenerateSteps(0.05m, 1, 0.05m).Select(x => (double)x) },
+    { "M", ValueGenerator.GenerateSteps(0.1m, 1, 0.1m).Select(x => (double)x) }
+  };
+
+  private static RandomForestClassificationSolution GridSearchWithCrossvalidation(IClassificationProblemData problemData, int numberOfCrossvalidationFolds, out RFParameter bestParameters,
+  int seed = 3141519) {
+    double rmsError, outOfBagRmsError, relClassificationError, outOfBagRelClassificationError;
+    bestParameters = RandomForestUtil.GridSearch(problemData, numberOfFolds, shuffleFolds, randomForestParameterRanges, seed, maximumDegreeOfParallelism);
+    var model = RandomForestModel.CreateClassificationModel(problemData, problemData.TrainingIndices, bestParameters.N, bestParameters.R, bestParameters.M, seed,
+                                                            out rmsError, out outOfBagRmsError, out relClassificationError, out outOfBagRelClassificationError);
+    return (RandomForestClassificationSolution)model.CreateClassificationSolution(problemData);
+  }
+
+  private static RandomForestClassificationSolution GridSearch(IClassificationProblemData problemData, out RFParameter bestParameters, int seed = 3141519) {
+    double rmsError, outOfBagRmsError, relClassificationError, outOfBagRelClassificationError;
+    bestParameters = RandomForestUtil.GridSearch(problemData, randomForestParameterRanges, seed, maximumDegreeOfParallelism);
+    var model = RandomForestModel.CreateClassificationModel(problemData, problemData.TrainingIndices, bestParameters.N, bestParameters.R, bestParameters.M, seed,
+                                                            out rmsError, out outOfBagRmsError, out relClassificationError, out outOfBagRelClassificationError);
+    return (RandomForestClassificationSolution)model.CreateClassificationSolution(problemData);
+  }
+
+  public override void Main() {
+    var variables = (Variables)vars;
+    var item = variables.SingleOrDefault(x => x.Value is IClassificationProblem || x.Value is IClassificationProblemData);
+    if (item.Equals(default(KeyValuePair<string, object>)))
+      throw new ArgumentException("Could not find a suitable problem or problem data.");
+
+    string name = item.Key;
+    IClassificationProblemData problemData;
+    if (item.Value is IClassificationProblem)
+      problemData = ((IClassificationProblem)item.Value).ProblemData;
+    else
+      problemData = (IClassificationProblemData)item.Value;
+
+    var bestParameters = new RFParameter();
+    var bestSolution = GridSearch(problemData, out bestParameters);
+    vars["bestSolution"] = bestSolution;
+    vars["bestParameters"] = bestParameters;
+
+    Console.WriteLine("Accuracy (training): " + bestSolution.TrainingAccuracy + ", Accuracy (test): " + bestSolution.TestAccuracy);
+    Console.WriteLine("Model parameters: n = {0}, r = {1}, m = {2}", bestParameters.N, bestParameters.R, bestParameters.M);
+  }
+}
Index: branches/ALPS/HeuristicLab.Tests/Test Resources/Script Sources/GridSearch_RF_Regression_Script.cs
===================================================================
--- branches/ALPS/HeuristicLab.Tests/Test Resources/Script Sources/GridSearch_RF_Regression_Script.cs	(revision 11677)
+++ branches/ALPS/HeuristicLab.Tests/Test Resources/Script Sources/GridSearch_RF_Regression_Script.cs	(revision 11677)
@@ -0,0 +1,74 @@
+using System;
+using System.Collections.Generic;
+using System.Linq;
+
+using HeuristicLab.Algorithms.DataAnalysis;
+using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Problems.Instances.DataAnalysis;
+using HeuristicLab.Random;
+using HeuristicLab.Scripting;
+
+public class RFRegressionCrossValidationScript : HeuristicLab.Scripting.CSharpScriptBase {
+  /* Maximum degree of parallelism (specifies whether or not the grid search should be parallelized) */
+  const int maximumDegreeOfParallelism = 4;
+  /* Number of crossvalidation folds: */
+  const int numberOfFolds = 3;
+  /* Specify whether the crossvalidation folds should be shuffled */
+  const bool shuffleFolds = true;
+
+  /* The tunable Random Forest parameters:
+     - "n" (number of trees). In the random forests literature, this is referred to as the ntree parameter.
+       Larger number of trees produce more stable models and covariate importance estimates, but require more memory and a longer run time.
+       For small datasets, 50 trees may be sufficient. For larger datasets, 500 or more may be required. Please consult the random forests
+       literature for extensive discussion of this parameter (e.g. Cutler et al., 2007; Strobl et al., 2007; Strobl et al., 2008).
+
+     - "r" The ratio of the training set that will be used in the construction of individual trees (0<r<=1). Should be adjusted depending on
+       the noise level in the dataset in the range from 0.66 (low noise) to 0.05 (high noise). This parameter should be adjusted to achieve
+       good generalization error.
+
+     - "m" The ratio of features that will be used in the construction of individual trees (0<m<=1)
+  */
+  static Dictionary<string, IEnumerable<double>> randomForestParameterRanges = new Dictionary<string, IEnumerable<double>> {
+    { "N", ValueGenerator.GenerateSteps(5m, 10, 1).Select(x => Math.Pow(2,(double)x)) },
+    { "R", ValueGenerator.GenerateSteps(0.05m, 1, 0.05m).Select(x => (double)x) },
+    { "M", ValueGenerator.GenerateSteps(0.1m, 1, 0.1m).Select(x => (double)x) }
+  };
+
+  private static RandomForestRegressionSolution GridSearchWithCrossvalidation(IRegressionProblemData problemData, out RFParameter bestParameters, int seed = 3141519) {
+    double rmsError, outOfBagRmsError, avgRelError, outOfBagAvgRelError;
+    bestParameters = RandomForestUtil.GridSearch(problemData, numberOfFolds, shuffleFolds, randomForestParameterRanges, seed, maximumDegreeOfParallelism);
+    var model = RandomForestModel.CreateRegressionModel(problemData, problemData.TrainingIndices, bestParameters.N, bestParameters.R, bestParameters.M, seed, out rmsError, out outOfBagRmsError, out avgRelError, out outOfBagAvgRelError);
+    return (RandomForestRegressionSolution)model.CreateRegressionSolution(problemData);
+  }
+
+  private static RandomForestRegressionSolution GridSearch(IRegressionProblemData problemData, out RFParameter bestParameters, int seed = 3141519) {
+    double rmsError, outOfBagRmsError, avgRelError, outOfBagAvgRelError;
+    var random = new MersenneTwister();
+    bestParameters = RandomForestUtil.GridSearch(problemData, randomForestParameterRanges, seed, maximumDegreeOfParallelism);
+    var model = RandomForestModel.CreateRegressionModel(problemData, problemData.TrainingIndices, bestParameters.N, bestParameters.R, bestParameters.M, seed,
+                                                        out rmsError, out outOfBagRmsError, out avgRelError, out outOfBagAvgRelError);
+    return (RandomForestRegressionSolution)model.CreateRegressionSolution(problemData);
+  }
+
+  public override void Main() {
+    var variables = (Variables)vars;
+    var item = variables.SingleOrDefault(x => x.Value is IRegressionProblem || x.Value is IRegressionProblemData);
+    if (item.Equals(default(KeyValuePair<string, object>)))
+      throw new ArgumentException("Could not find a suitable problem or problem data.");
+
+    string name = item.Key;
+    IRegressionProblemData problemData;
+    if (item.Value is IRegressionProblem)
+      problemData = ((IRegressionProblem)item.Value).ProblemData;
+    else
+      problemData = (IRegressionProblemData)item.Value;
+
+    var bestParameters = new RFParameter();
+    var bestSolution = GridSearch(problemData, out bestParameters);
+    vars["bestSolution"] = bestSolution;
+    vars["bestParameters"] = bestParameters;
+
+    Console.WriteLine("R2 (training): " + bestSolution.TrainingRSquared + ", R2 (test): " + bestSolution.TestRSquared);
+    Console.WriteLine("Model parameters: n = {0}, r = {1}, m = {2}", bestParameters.N, bestParameters.R, bestParameters.M);
+  }
+}
